diff -urN u-boot/cpu/mpc5xxx/serial.c u-boot-pscfix-20040114/cpu/mpc5xxx/serial.c
--- u-boot/cpu/mpc5xxx/serial.c	2003-07-16 23:53:03.000000000 +0200
+++ u-boot-pscfix-20040114/cpu/mpc5xxx/serial.c	2004-01-16 11:06:57.000000000 +0100
@@ -67,10 +67,10 @@
 	/* select clock sources */
 #if defined(CONFIG_MGT5100)
 	psc->psc_clock_select = 0xdd00;
-	baseclk = CFG_MPC5XXX_CLKIN / 32;
+	baseclk = (CFG_MPC5XXX_CLKIN + 16) / 32;
 #elif defined(CONFIG_MPC5200)
 	psc->psc_clock_select = 0;
-	baseclk = gd->ipb_clk / 32;
+	baseclk = (gd->ipb_clk + 16) / 32;
 #endif
 
 	/* switch to UART mode */
@@ -85,8 +85,8 @@
 	psc->mode = PSC_MODE_ONE_STOP;
 
 	/* set up UART divisor */
-	div = baseclk / gd->baudrate;
-	psc->ctur = div >> 8;
+	div = (baseclk + (gd->baudrate/2)) / gd->baudrate;
+	psc->ctur = (div >> 8) & 0xff;
 	psc->ctlr = div & 0xff;
 
 	/* disable all interrupts */
